#include "stdlib.h"

int _streq(const char* i,const char* ii)
{
  while(*i++==*ii++)
  {
    if(*i==0&&*ii==0)
      return 1;
  }
  return 0;
}

#define ISNUMBER(x) (x>='0'&&x<='9'||x==','||x=='.'||x=='-')

//       

int haveletters(const char* i)
{
  while(*i!=0)
  {
    if(!ISNUMBER(*i))
      return 1;
    i++;
  }
  return 0;
}

int _stringformatcmp(const char* i,const char* ii)
{
  if(*i=='"'&&*ii=='"')
  {
    int len1=_strlen(i);
    int len2=_strlen(ii);
    if(len1==len2)
      return _strcmp(i,ii);
    return len1<len2?-1:1;
  }
  if(*i=='"')
    return _strncmp(i+1,ii,_strlen(i)-2);
  if(*ii=='"')
    return _strncmp(i,ii+1,_strlen(ii)-2);
  if(haveletters(i)||haveletters(ii))
    return _strcmp(i,ii);
  return atof(i)<atof(ii);
}

int _strcmp(const char* i,const char* ii)
{
  while(*i==*ii)
  {
    if(*i==0) //      
      return 0;
    ii++;
    i++;
  }
  return (unsigned char)*i<(unsigned char)*ii?-1:1;
}

int _strncmp(const char* i,const char* ii,int count)
{
  while(*i==*ii&&count--)
  {
    if(*i==0) //      
      return 0;
    ii++;
    i++;
  }
  return count==0?0:*i<*ii?-1:1;
}

int _strcpy(char* p,const char* pp)
{
  while(*p++=*pp++)
    ;
  return 1;
}

int _strlen(const char* p)
{
  int len=0;
  while(*p++)
    len++;
  return len;
}

int findinnumarray(int * flds,int fldscount,int what)
{
  int i;
  for(i=0;i<fldscount;i++)
  {
    if(flds[i]==what)
      return i;
  }
  return -1;
}

int findinarray(fieldname * flds,const char* what)
{
  int count=0;
  while(!_streq(*flds++,what))
    count++;
  return count;
}

void * _memcpy( void *dest, const void *src, int count )
{
  unsigned char *d=(unsigned char *)dest,*s=(unsigned char *)src;
  while(count--)
    *d++=*s++;
  return 0;
}

void * _memset( void *dest, int c, int count )
{
  unsigned char *d=(unsigned char *)dest;
  while(count--)
    *d++=c;
  return 0;
}
